/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmTablegroupRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmTablegroup extends TableImpl<VDmTablegroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_tablegroup</code>
     */
    public static final VDmTablegroup V_DM_TABLEGROUP = new VDmTablegroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmTablegroupRecord> getRecordType() {
        return VDmTablegroupRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_tablegroup.group_id</code>.
     */
    public final TableField<VDmTablegroupRecord, Integer> GROUP_ID = createField(DSL.name("group_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_tablegroup.group_name</code>.
     */
    public final TableField<VDmTablegroupRecord, String> GROUP_NAME = createField(DSL.name("group_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_tablegroup.group_order</code>.
     */
    public final TableField<VDmTablegroupRecord, Integer> GROUP_ORDER = createField(DSL.name("group_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_tablegroup.fk_element</code>.
     */
    public final TableField<VDmTablegroupRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_tablegroup.short_name</code>.
     */
    public final TableField<VDmTablegroupRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_tablegroup.table_order</code>.
     */
    public final TableField<VDmTablegroupRecord, Integer> TABLE_ORDER = createField(DSL.name("table_order"), SQLDataType.INTEGER, this, "");

    private VDmTablegroup(Name alias, Table<VDmTablegroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmTablegroup(Name alias, Table<VDmTablegroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_tablegroup" as  SELECT tg.pk AS group_id,
         tg.table_grp AS group_name,
         tg.table_grp_order AS group_order,
         td.fk_element,
         eh.short_name,
         tgd.table_order
        FROM (((common_dd.t_dm_tablegrp tg
          LEFT JOIN common_dd.t_dm_tablegrpdetail tgd ON ((tg.pk = tgd.fk_table_grp)))
          LEFT JOIN common_dd.t_dm_tabledef td ON ((tgd.fk_tabledef = td.pk)))
          LEFT JOIN common_dd.v_core_element_tree eh ON ((td.fk_element = eh.key_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_tablegroup</code> table reference
     */
    public VDmTablegroup(String alias) {
        this(DSL.name(alias), V_DM_TABLEGROUP);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_tablegroup</code> table reference
     */
    public VDmTablegroup(Name alias) {
        this(alias, V_DM_TABLEGROUP);
    }

    /**
     * Create a <code>common_dd.v_dm_tablegroup</code> table reference
     */
    public VDmTablegroup() {
        this(DSL.name("v_dm_tablegroup"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmTablegroup as(String alias) {
        return new VDmTablegroup(DSL.name(alias), this);
    }

    @Override
    public VDmTablegroup as(Name alias) {
        return new VDmTablegroup(alias, this);
    }

    @Override
    public VDmTablegroup as(Table<?> alias) {
        return new VDmTablegroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablegroup rename(String name) {
        return new VDmTablegroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablegroup rename(Name name) {
        return new VDmTablegroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablegroup rename(Table<?> name) {
        return new VDmTablegroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup where(Condition condition) {
        return new VDmTablegroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablegroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablegroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablegroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablegroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablegroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
